/* eslint-disable no-await-in-loop */
import type { TextChannel } from 'eris';
import { Client, RichEmbed } from '../class';

export default (client: Client) => {
  const interval = setInterval(async () => {
    const motions = await client.db.Motion.find({ processed: false });
    const directorLogs = <TextChannel>client.getChannel('807444198969835550');

    for (const motion of motions) {
      const motionMessage = await directorLogs.getMessage(motion.motionMessage);

      if ((Date.now() - motionMessage.createdAt) > 86400) {
        const yea = await motionMessage.getReaction(client.util.emojis.SUCCESS);
        const nay = await motionMessage.getReaction(client.util.emojis.ERROR);
        const present = yea.length + nay.length;
        const totalDirectors = 5;
        const absent = totalDirectors - present;

        await client.db.Motion.updateOne({ oID: motion.oID }, {
          processed: true,
          voteResults: {
            yea: yea.length,
            nay: nay.length,
            present,
            absent,
          },
        });
        await client.db.Resolution.create({
          issuedBy: motion.issuedBy,
          subject: motion.subject,
          body: motion.body,
          at: motion.at,
          oID: motion.oID,
          voteResults: {
            yea: yea.length,
            Nay: nay.length,
            present,
            absent,
          },
          acceptedAt: Date.now(),
        });

        const directorDiscord = client.users.get(motion.issuedBy);
        const directorProfile = await client.db.Staff.findOne({ userID: motion.issuedBy });

        const embed = new RichEmbed();
        embed.setAuthor(`${directorDiscord.username}#${directorDiscord.discriminator}, ${directorProfile.pn.join(', ')}`, directorDiscord.avatarURL);
        embed.setTitle('Resolution');
        embed.setFooter(`${directorProfile.position} | Library of Code sp-us | Board of Directors`, 'https://static.libraryofcode.org/loccommunityadmin.png');
        let colour;
        if (yea.length > nay.length) colour = '#27b17a';
        else if (yea.length === nay.length) colour = '#ffb34d';
        else colour = '#ff474a';
        embed.setColor(colour);
        embed.setDescription(motion.oID);
        embed.addField('Result', `- **Yea:** ${yea.length}\n**Nay:** ${nay.length}\n**Present:** ${present}\n**Absent:** ${absent}\n**Total:** ${present + absent}`);
        embed.setTimestamp();

        await directorLogs.createMessage({ content: directorDiscord.mention, embed });
      }
    }
  }, 300000);

  return interval;
};
